/*************************************************************
	Class that represents the entire sco. This is the main
	control center. It contains the function to talk to the 
	LMS via APIWRAPPER.js.
*************************************************************/
var sco = new SCO(); 


function SCO()
{
	this.debug = false;
	this.LMSinitResult = "false";

	this.startTime;	 	//Keep track of how long the user used this sco.

	
	//Called to start communication with the LMS. 
	this.beginLMSCommunication = function()
	{
		if(this.debug){alert('sco.beginLMSCommunication() called')}
   		var api = getAPIHandle();//found in APIWrapper.js
   		if (api == null)
   		{
      		alert("Unable to locate the LMSs API Implementation.\n -sco.beginLMSCommunication() was not successful.");
      		return "false";
   		}else
		{
			this.LMSinitResult = LMSInitialize();//returns string "true"
			if(this.LMSinitResult == "false")
			{
				alert("Unable to Initalize LMS.")
			}
			var start_date = new Date();
			this.startTime = start_date.getTime();
		}
	}
	
	//This will be used to end communication with the LMS. 
	this.endLMSCommunication = function()
	{
		if(this.LMSinitResult == "true")
		{
			this.LMSinitResult = "false";
			
			var mode = LMSGetValue( "cmi.core.lesson_mode" );
			if ( mode != "review"  &&  mode != "browse" )
			{
				this.updateLMSLessonTime();
			}		
			
			LMSSetValue("cmi.core.lesson_status","completed"); 
			LMSSetValue( "cmi.core.exit", "" );
			LMSCommit();
			LMSFinish();
			if(this.debug){alert('sco.endLMSCommunication: LMSFinish called')}
		}
	}	
	
	//Record how long this page has been open.
	this.updateLMSLessonTime = function()
	{
		//create a new date object for the end time
		var now = new Date();
		//get the end time, in milliseconds
		var end_time = now.getTime();
		//calculate the elapsed time, convert to seconds, and rounded to nearest integer
		var session_time_sec = Math.round((end_time - this.startTime)/1000);
		
		//convert to hr,min,sec
		seconds = session_time_sec % 60;
		var total_minutes = Math.floor(session_time_sec / 60);
		minutes = total_minutes % 60;
		hours = Math.floor(total_minutes / 60);
		
		//convert values to strings
		seconds = seconds.toString();
		minutes = minutes.toString();
		hours = hours.toString();
			
		//check for length of strings, pad out if necessary
		if(seconds.length == 1){seconds = "0" + seconds}
		if(minutes.length == 1){minutes = "0" + minutes}
		if(hours.length == 1){hours = "0" + hours}
		
		//concatenate h,min,sec to lms format
		session_time_string = hours + ":" + minutes + ":" + seconds;
		//finally, upload the session time to the lms
		LMSSetValue("cmi.core.session_time",session_time_string);
		//if(debug){alert("session_time_string = "+ session_time_string)}
	}	
	
}